org.eclipse.viatra.query.runtime.rete.util

## Class ReteHintOptions

- java.lang.Object
- - org.eclipse.viatra.query.runtime.rete.util.ReteHintOptions

-     public final class ReteHintOptions
      extends java.lang.Object

  Provides key objects (of type `QueryHintOption`) for `QueryEvaluationHint`s.
  Since:
    1.5

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static QueryHintOption<java.lang.Boolean>` | `cacheOutputOfEvaluatorsByDefault`
    `static QueryHintOption<java.lang.Boolean>` | `deleteRederiveEvaluation` Deprecated. Use `DRedReteBackendFactory` instead of setting this option to true.
    `static QueryHintOption<java.lang.Boolean>` | `expandWeakenedAlternativeConstraints` This hint allows the query planner to take advantage of "weakened alternative" suggestions of the meta context.
    `static QueryHintOption<java.lang.Boolean>` | `prioritizeConstantFiltering`
    `static QueryHintOption<java.lang.Boolean>` | `useDiscriminatorDispatchersForConstantFiltering`

  - ### Method Summary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### useDiscriminatorDispatchersForConstantFiltering

          public static final QueryHintOption<java.lang.Boolean> useDiscriminatorDispatchersForConstantFiltering

    - #### prioritizeConstantFiltering

          public static final QueryHintOption<java.lang.Boolean> prioritizeConstantFiltering

    - #### cacheOutputOfEvaluatorsByDefault

          public static final QueryHintOption<java.lang.Boolean> cacheOutputOfEvaluatorsByDefault

    - #### deleteRederiveEvaluation

          @Deprecated
          public static final QueryHintOption<java.lang.Boolean> deleteRederiveEvaluation

      Deprecated. Use `DRedReteBackendFactory` instead of setting this option to true.
      The incremental query evaluator backend can evaluate recursive patterns. However, by default, instance models that contain cycles are not supported with recursive queries and can lead to incorrect query results. Enabling Delete And Rederive (DRED) mode guarantees that recursive query evaluation leads to correct results in these cases as well.

      As DRED may diminish the performance of incremental maintenance, it is not enabled by default.

      Since:
        1.6

    - #### expandWeakenedAlternativeConstraints

          public static final QueryHintOption<java.lang.Boolean> expandWeakenedAlternativeConstraints

      This hint allows the query planner to take advantage of "weakened alternative" suggestions of the meta context. For instance, enumerable unary type constraints may be substituted with a simple type filtering where sufficient.
      Since:
        1.6